Subject: Re: git: list of my complaints about future graft removal

From: Junio C Hamano <[email-masked]>
Date: Mon, 25 Aug 2025 16:36:46 -0700

Bagas Sanjaya <[email-masked]> writes:

> On Tue, Aug 19, 2025 at 05:57:08PM +0400, Askar Safin wrote:
>> * As well as I understand, "git clone --depth=1" rely on grafts, too.
>> I hope "git clone --depth=1" will continue to work.
>
> So shallow clones should use git-replace(1) under the hood (both on initial
> clone, deepening with --shallow-since and --unshallow), right?

An unfortunate historical glitch is that shallow uses neither the
grafts (which is being removed) nor replace but its own mechanism.
It internally borrows the same "graft" code paths but the data is
stored outside the normal grafts mechanism, if I understand
correctly.